#include "spi1.h"
void initSPI1()
{
	// Turn on SPI1 clock
	RCC_APB2ENR |= BIT12;
	// reset the SPI1 interface
	RCC_APB2RSTR |= BIT12;
	delay(10);
	RCC_APB2RSTR &= ~BIT12;
	// GYRON is on PA5,6,7 and PE3 
	// Turn on GPIOA and GPIOE
	RCC_AHBENR |= (BIT17+BIT21);
	// Select alternate function for pins in question on GPIOA
	GPIOA_MODER |= (BIT15+BIT13+BIT11);
	GPIOA_MODER &= ~(BIT14+BIT12+BIT10);
	// PE3 is a general purpose output port
	GPIOE_MODER &= ~(BIT7);
	GPIOE_MODER |= (BIT6);
	// AF5 = SPI on PORTA pins
	GPIOA_AFRL &= 0x000fffff; // clear upper bits
	GPIOA_AFRL |= 0x55500000; // select AF5
	// set gyro into spi idle mode
	GPIOE_ODR |= BIT3; 	
	
	SPI1_CR2 = (0x07 << 8); // 8 bits per transfer	
	// setup the SPI operating modes etc
	SPI1_CR1 = BIT2+BIT9+(7<<3)+BIT6+BIT8+BIT1+BIT0;
}
void spi_write(int SubAddress, int Value)
{
	short RValue;
	int timeout;
	timeout=SPI_TIMEOUT;
	GPIOE_ODR &= ~BIT3; // Drive CS low
	SPI1_DR = (short)((Value << 8)+SubAddress);
	RValue=SPI1_SR;
	while ( (timeout--) && ((SPI1_SR & BIT7)!=0) ); // wait for tx complete
	RValue = SPI1_DR; // dummy read of data register
	GPIOE_ODR |= BIT3;  // Drive CS High
}
int spi_read(int SubAddress)
{
	short RValue;
	int timeout;
	timeout=SPI_TIMEOUT;
	GPIOE_ODR &= ~BIT3; // Drive CS low
	SPI1_DR = ((SubAddress | 0x80)); // output subaddress + read flag
	while ((timeout--) && ((SPI1_SR & BIT7)!=0) ); // wait for tx complete
	RValue = SPI1_DR >>8 ;
	GPIOE_ODR |= BIT3;  // Drive CS High
	return RValue;
}
void ClearSPIMODF()
{
	int dummy = SPI1_SR; 
	dummy = SPI1_CR1;
	SPI1_CR1 = dummy;
}
